unit uMain;

{$mode objfpc}{$H+}

interface

uses
 Classes, SysUtils, FileUtil, ZConnection, Forms, Controls, Graphics, Dialogs,
	StdCtrls, Spin, ZDataset, syncobjs;

type

	{ TCThread }

 TCThread = class(TThread)
 private
  lConnection: TZConnection;
  lQuery: TZQuery;
  ID_: Integer;
  CS: TCriticalSection;
  msgfrmMain: string;
 protected
  procedure Execute; override;
  procedure LogMain;
  procedure frmMainException;
 public
   constructor Create(ID: Integer);
   destructor Destroy; override;
 end;

 { TfrmMain }

 TfrmMain = class(TForm)
		Button2: TButton;
  Label1: TLabel;
  Memo1: TMemo;
  seThreadCount: TSpinEdit;
  ZConnection1: TZConnection;
  procedure Button2Click(Sender: TObject);
  procedure FormCreate(Sender: TObject);
 private
  //lThread: TLogThread;
  //tm: TMySQLTest;
  cThread: TCThread;
 public
  { public declarations }
 end;

var
 frmMain: TfrmMain;
 LPath: string;

//{$define mysql}

const
//{$ifdef mysql}
//  dbLibFileName = 'libmysql.dll';
//  driverName = 'mysql';
//  db_Host = '127.0.0.1'; //'127.0.0.1';  // <-- or change
//  db_Port = 3306;
//  db_Name = 'test';
//  db_username = 'username';
//  db_password = 'password';
//{$else}
//  dbLibFileName = 'libpq.dll';
//  driverName = 'postgresql-9';
//  db_Host = '127.0.0.1';  // <-- or change
//  db_Port = 5432;
//  db_Name = 'test';
//  db_username = 'username';
//  db_password = 'password';
//{$endif}

  dbLibFileName = 'ntwdblib.dll';
  driverName = 'mssql';
  db_Host = '10.0.1.96';  // <-- or change
  db_Port = 1433;
  db_Name = 'test';
  db_username = 'username';
  db_password = 'password';

implementation

{$R *.lfm}

{ TCThread }

procedure TCThread.Execute;
begin
  lConnection:=TZConnection.Create(nil);
  lConnection.LibraryLocation:=LPath + dbLibFileName;
  lConnection.HostName:=db_Host;                    // <--- change const
  lConnection.Port:=db_Port;                        // <--- change const
  lConnection.Database:=db_Name;                    // <--- change const
  lConnection.User:=db_username;                    // <--- change const
  lConnection.Password:=db_password;                // <--- change const
  lConnection.LoginPrompt:=False;
  lConnection.Protocol:=driverName;
  lConnection.ClientCodepage:='UTF8';
  lConnection.AutoEncodeStrings:=True;
  lConnection.UseMetadata:=True;

  try
    lConnection.Connect;
  except
    lConnection.Free;
    Exit;
  end;
	  lQuery:=TZQuery.Create(nil);
	  lQuery.Connection:=lConnection;

  try
//{$ifdef mysql}
//    lQuery.SQL.Text:='select * from `log`';   //<- please, change for your table
//{$else}
//    lQuery.SQL.Text:='select * from log';   //<- please, change for your table
//{$endif}
    lQuery.SQL.Text:='select * from log';   //<- please, change for your table
    lQuery.Open;
	 finally
    Synchronize(@LogMain);
	 end;
end;

procedure TCThread.LogMain;
begin
  frmMain.Memo1.Lines.Add('Thread ' + IntToStr(ID_) + ' finished');
end;

procedure TCThread.frmMainException;
begin
 frmMain.Memo1.Lines.Add('Thread ' + IntToStr(ID_) + ' EXCEPTION, message: ' + msgfrmMain);
end;

constructor TCThread.Create(ID: Integer);
begin
  inherited Create(False);
  CS:=TCriticalSection.Create;
  CS.Acquire;
  CS.Enter;
  FreeOnTerminate:=True;
  ID_:=ID;
end;

destructor TCThread.Destroy;
begin
 try
   lQuery.Close;
   lQuery.Free;

   lConnection.Disconnect;
   lConnection.Free;
 except
  on E: Exception do
    begin
      msgfrmMain:=E.Message;
      Synchronize(@frmMainException);
    end;
 end;
  CS.Leave;
  FreeAndNil(CS);
  inherited Destroy;
end;

{ TfrmMain }

procedure TfrmMain.FormCreate(Sender: TObject);
begin
  LPath:=IncludeTrailingPathDelimiter(ExtractFilePath(Application.ExeName));
  ZConnection1.LibraryLocation:=LPath + dbLibFileName;
  ZConnection1.HostName:=db_Host;                    // <--- change const
  ZConnection1.Port:=db_Port;                        // <--- change const
  ZConnection1.Database:=db_Name;                    // <--- change const
  ZConnection1.User:=db_username;                    // <--- change const
  ZConnection1.Password:=db_password;                // <--- change const
  ZConnection1.LoginPrompt:=False;
  ZConnection1.Protocol:=driverName;
  ZConnection1.ClientCodepage:='UTF8';
  ZConnection1.AutoEncodeStrings:=True;
  ZConnection1.UseMetadata:=True;
  ZConnection1.Connect;
end;

procedure TfrmMain.Button2Click(Sender: TObject);
var
  I: Integer;
begin
 for I:=1 to seThreadCount.Value do
  TCThread.Create(I);
end;

end.
